//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Library General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef CITYLIST_H
#define CITYLIST_H

#include "ObjectList.h"
#include <paragui.h>
#include <sigc++/object_slot.h>

class City;
class Player;

class Citylist : public ObjectList<City>, public SigC::Object
{
	public:
		// CREATORS
		Citylist();
		Citylist(XML_Helper* helper);
		~Citylist();

		// MANIPULATORS
		void nextTurn();
		bool save(XML_Helper* helper);
		
		// ACCESSORS
		int countCities(Player* p) const;
		bool load(std::string tag, XML_Helper* helper);
		City* getNearestEnemyCity(const PG_Point& pos);
};

//these classes don't really belong here, but they have already been here as
//typedefs and they only extend objectlist by one function

class Ruinlist : public ObjectList<Ruin>, public SigC::Object
{
    public:
        Ruinlist();
        Ruinlist(XML_Helper* helper);
        
        bool save(XML_Helper* helper);
        bool load(std::string tag, XML_Helper* helper);
};

class TempleList : public ObjectList<Temple>, public SigC::Object
{
	public:
        TempleList();
		TempleList(XML_Helper* helper);

		bool save(XML_Helper* helper);
		bool load(std::string tag, XML_Helper* helper);
};

extern Citylist* citylist;
extern Ruinlist* ruinlist;
extern TempleList* templeList;

#endif // CITYLIST_H

// End of file
